package com.logicbig.example;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.io.PrintWriter;

@WebServlet(name = "userBalanceServlet", urlPatterns = {"/balance"})
public class BalanceServlet extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {

        HttpSession session = req.getSession();
        User user = (User) session.getAttribute("loggedInUser");
        if (user == null) {
            RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/login");
            dispatcher.forward(req, resp);
        } else {
            prepareBalanceInfoHtml(user, resp);
            req.changeSessionId();
        }
    }

    private void prepareBalanceInfoHtml(User user, HttpServletResponse resp) throws IOException {
        resp.setContentType("text/html");
        PrintWriter w = resp.getWriter();
        w.write("User logged in " + user.getName());
        w.write("<br/>Balance: " + user.getCurrentBalance());
    }
}