package com.logicbig.example;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigDecimal;

@WebServlet(name = "userLoginServlet", urlPatterns = {"/login"})
public class LogInServlet extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {

        HttpSession session = req.getSession();
        String userKey = "loggedInUser";
        User user = (User) session.getAttribute(userKey);
        if (user == null) {
            user = loadUserForRequest(req);
            session.setAttribute(userKey, user);
        }
        prepareLogginInfoHtml(user, resp);
        req.changeSessionId();
    }

    private void prepareLogginInfoHtml(User user, HttpServletResponse resp)
            throws IOException {
        resp.setContentType("text/html");
        PrintWriter w = resp.getWriter();
        w.write("User logged in " + user.getName());
        w.write("<br/><a href='/balance'>Show Balance</a>");
    }

    private User loadUserForRequest(HttpServletRequest req) {
        //returning a dummy user
        return new User("1", "Mike", "12312",
                BigDecimal.valueOf(200000));
    }
}